# Custom Rotation - Creates a checkpoint that keeps player's orientation

# Use this command to set a checkpoint:
# /scoreboard players set <selector> spawn_ucs <score>
execute as @e[scores={spawn_ucs=1..}] store result score @s x_ucs run data get entity @s Pos[0] 1000
execute as @e[scores={spawn_ucs=1..}] store result score @s y_ucs run data get entity @s Pos[1] 1000
execute as @e[scores={spawn_ucs=1..}] store result score @s z_ucs run data get entity @s Pos[2] 1000
execute as @e[scores={spawn_ucs=1..}] store result score @s yr_ucs run data get entity @s Rotation[0] 100
execute as @e[scores={spawn_ucs=1..}] store result score @s xr_ucs run data get entity @s Rotation[1] 100
execute as @e[scores={spawn_ucs=1..}] at @s run spawnpoint @s ~ ~ ~

# Set Rotation - Creates checkpoints with a set orientation

# These commands will face the player towards the ground or the sky; y axis rotation is kept.
execute as @e[scores={spawn_ucs=2}] run scoreboard players set @s xr_ucs 9000
execute as @e[scores={spawn_ucs=3}] run scoreboard players set @s xr_ucs -9000
# These commands will face the player towards one of the four cardinal directions; the first command changes the x axis rotation for all the four directions.
execute as @e[scores={spawn_ucs=4..7}] run scoreboard players set @s xr_ucs 0
execute as @e[scores={spawn_ucs=4}] run scoreboard players set @s yr_ucs 0
execute as @e[scores={spawn_ucs=5}] run scoreboard players set @s yr_ucs 9000
execute as @e[scores={spawn_ucs=6}] run scoreboard players set @s yr_ucs 18000
execute as @e[scores={spawn_ucs=7}] run scoreboard players set @s yr_ucs -9000

# spawn_ucs is reset immediately after the checkpoint is set
scoreboard players set @e[scores={spawn_ucs=1..}] spawn_ucs 0

# Respawn Controller - Controls the respawn event

# Use this command to teleport to the checkpoint the targeted entities: 
# /scoreboard players set <selector> respawn_ucs 1
# One by one, each entity targeted will be respawned; this means that a great number of entities could take a while: seconds = n(n-1)/20.
scoreboard players add @e[scores={respawn_ucs=-2..-1}] respawn_ucs 1
scoreboard players add @e[scores={respawn_ucs=1..},limit=1] respawn_ucs 1
execute as @e[scores={respawn_ucs=2}] at @s run summon armor_stand ~ ~ ~ {NoGravity:true,Marker:true,Invisible:true,Tags:["respawn_ucs"]}
execute as @e[scores={respawn_ucs=2}] at @s store result entity @e[tag=respawn_ucs,limit=1,sort=nearest] Pos[0] double 0.001 run scoreboard players get @s x_ucs
execute as @e[scores={respawn_ucs=2}] at @s store result entity @e[tag=respawn_ucs,limit=1,sort=nearest] Pos[1] double 0.001 run scoreboard players get @s y_ucs
execute as @e[scores={respawn_ucs=2}] at @s store result entity @e[tag=respawn_ucs,limit=1,sort=nearest] Pos[2] double 0.001 run scoreboard players get @s z_ucs
execute as @e[scores={respawn_ucs=2}] at @s store result entity @e[tag=respawn_ucs,limit=1,sort=nearest] Rotation[0] float 0.01 run scoreboard players get @s yr_ucs
execute as @e[scores={respawn_ucs=2}] at @s store result entity @e[tag=respawn_ucs,limit=1,sort=nearest] Rotation[1] float 0.01 run scoreboard players get @s xr_ucs
tp @e[scores={respawn_ucs=2},limit=1] @e[tag=respawn_ucs,limit=1,sort=nearest]
execute as @e[tag=respawn_ucs] at @s run scoreboard players set @e[scores={respawn_ucs=2..},limit=1,sort=nearest] respawn_ucs 5
execute as @e[scores={respawn_ucs=5}] run kill @e[tag=respawn_ucs]
execute as @e[scores={respawn_ucs=3}] run kill @e[tag=respawn_ucs]
kill @e[scores={respawn_ucs=4,death_ucs=5..}]
scoreboard players set @e[scores={respawn_ucs=4..}] respawn_ucs -2
# In a command, to target an entity that has just respawned, use @e[scores={respawn_ucs=-2..-1}]

# Death Rotation - Keeps player's rotation even if killed naturally

scoreboard players set @e[scores={death_ucs=1}] respawn_ucs 1

# Thanks to Maxaxik and Qianna for helping with this part of the function.

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Custom Checkpoint - Create a checkpoint without using entity position

# To create a checkpoint, use in this order these commands:
# /execute at @p run summon armor_stand ~ ~ ~ {NoGravity:true,Marker:true,Invisible:true,Marker:true,Tags:["custom_ucs"]}
# /execute store success score <selector> custom_ucs run tp @e[tag=custom_ucs] <x y z> <y rotation> <x rotation>

# If the checkpoint will be in a loaded chunk, you can use just this command:
# /execute store success score <selector> custom_ucs run summon armor_stand <x y z> {Invisible:true,Tags:["custom_ucs"],Rotation:[<y rotation>f,<x rotation>f]}

# Change <selector> to the entities you want to set the checkpoint for.
# Change the coordinates and the rotations to where you like to set the checkpoint.
# Use the single command only if you need to reduce to a minimum the number of commands; for most needs you're better off using the two commands.

execute as @e[tag=custom_ucs] store result score @e[scores={custom_ucs=1}] x_ucs run data get entity @s Pos[0] 1000
execute as @e[tag=custom_ucs] store result score @e[scores={custom_ucs=1}] y_ucs run data get entity @s Pos[1] 1000
execute as @e[tag=custom_ucs] store result score @e[scores={custom_ucs=1}] z_ucs run data get entity @s Pos[2] 1000
execute as @e[tag=custom_ucs] store result score @e[scores={custom_ucs=1}] yr_ucs run data get entity @s Rotation[0] 100
execute as @e[tag=custom_ucs] store result score @e[scores={custom_ucs=1}] xr_ucs run data get entity @s Rotation[1] 100
execute as @e[scores={custom_ucs=1}] run kill @e[tag=custom_ucs]
scoreboard players set @e[scores={custom_ucs=1}] custom_ucs 0

# This data pack can be used freely; if you do intend to use this data pack for a custom map, you have to credit the creator, PmkExpert, in a visible way.
# Contact on Reddit for any question: https://www.reddit.com/user/Pmk23